import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class EditeurtypeRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "GODIN.EDITEURTYPE";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

  private static final EditeurtypeRef _EditeurtypeRefFactory = new EditeurtypeRef();

  public static ORADataFactory getORADataFactory()
  { return _EditeurtypeRefFactory; }
  /* constructor */
  public EditeurtypeRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    EditeurtypeRef r = new EditeurtypeRef();
    r._ref = (REF) d;
    return r;
  }

  public Editeurtype getValue() throws SQLException
  {
     return (Editeurtype) Editeurtype.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(Editeurtype c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
