import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.REF;
import oracle.sql.STRUCT;

public class TypedonnesanneRef implements ORAData, ORADataFactory
{
  public static final String _SQL_BASETYPE = "GODIN.TYPEDONNESANNE";
  public static final int _SQL_TYPECODE = OracleTypes.REF;

  REF _ref;

  private static final TypedonnesanneRef _TypedonnesanneRefFactory = new TypedonnesanneRef();

  public static ORADataFactory getORADataFactory()
  { return _TypedonnesanneRefFactory; }
  /* constructor */
  public TypedonnesanneRef()
  {
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _ref;
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null;
    TypedonnesanneRef r = new TypedonnesanneRef();
    r._ref = (REF) d;
    return r;
  }

  public Typedonnesanne getValue() throws SQLException
  {
     return (Typedonnesanne) Typedonnesanne.getORADataFactory().create(
       _ref.getSTRUCT(), OracleTypes.REF);
  }

  public void setValue(Typedonnesanne c) throws SQLException
  {
    _ref.setValue((STRUCT) c.toDatum(_ref.getJavaSqlConnection()));
  }
}
